<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="标准化等级" prop="stanGrad">
        <el-select v-model="queryParams.stanGrad" placeholder="请选择标准化等级" clearable>
          <el-option v-for="dict in eutr_cert_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="证书状态" prop="certStat">
        <el-select v-model="queryParams.certStat" placeholder="请选择证书状态" clearable>
          <el-option v-for="dict in eutr_cert_stat" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="证书编号" prop="stanCertCode">
        <el-input v-model="queryParams.stanCertCode" placeholder="请输入证书编号" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['stan:stancert:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['stan:stancert:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['stan:stancert:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['stan:stancert:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="stan-stancert-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="证书编号" prop="stanCertCode" />
      <el-table-column label="标准化等级" prop="stanGrad" width="120">
        <template #default="scope">
          <dict-tag :options="eutr_cert_type" :value="scope.row.stanGrad" />
        </template>
      </el-table-column>
      <el-table-column label="发证时间" prop="issueTime" width="180" />
      <el-table-column label="证书到期时间" prop="certExpiTime" width="180" />
      <el-table-column label="证书状态" prop="certStat" width="120">
        <template #default="scope">
          <dict-tag :options="eutr_cert_stat" :value="scope.row.certStat" />
        </template>
      </el-table-column>
      <el-table-column label="颁发单位编码" prop="issueWiunCode" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['stan:stancert:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['stan:stancert:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="750px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="证书编号" prop="stanCertCode">
          <el-input v-model="form.stanCertCode" placeholder="请输入证书编号" />
        </el-form-item>
        <el-form-item label="标准化等级" prop="stanGrad">
          <el-select v-model="form.stanGrad" placeholder="请选择标准化等级">
            <el-option v-for="dict in eutr_cert_type" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="所属组织" prop="orgGuid">
          <el-input v-model="form.orgGuid" placeholder="请输入所属组织" />
        </el-form-item>
        <el-form-item label="发证时间" prop="issueTime">
          <el-date-picker v-model="form.issueTime" type="datetime" placeholder="选择发证时间" clearable />
        </el-form-item>
        <el-form-item label="证书到期时间" prop="certExpiTime">
          <el-date-picker v-model="form.certExpiTime" type="datetime" placeholder="选择证书到期时间" clearable />
        </el-form-item>
        <el-form-item label="证书状态" prop="certStat">
          <el-select v-model="form.certStat" placeholder="请选择证书状态">
            <el-option v-for="dict in eutr_cert_stat" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="颁发单位编码" prop="issueWiunCode">
          <el-input v-model="form.issueWiunCode" placeholder="请输入颁发单位编码" />
        </el-form-item>
        <el-form-item label="评审GUID" prop="stanReviGuid">
          <el-input v-model="form.stanReviGuid" placeholder="请输入评审GUID" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="StanCert">
import { listBisStanCert, getBisStanCert, addBisStanCert, updateBisStanCert, delBisStanCert } from "@/api/slaj/stan";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { eutr_cert_type, eutr_cert_stat } = proxy.useDict("eutr_cert_type", "eutr_cert_stat");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ stanCertCode: { visible: true }, stanGrad: { visible: true }, issueTime: { visible: true }, certExpiTime: { visible: true }, certStat: { visible: true }, issueWiunCode: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, stanGrad: null, certStat: null, stanCertCode: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisStanCert(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加标准化证书";
}

function handleUpdate(row) {
  reset();
  getBisStanCert(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改标准化证书";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisStanCert(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisStanCert(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisStanCert(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/stan/stancert/export', { ...queryParams.value }, `标准化证书_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, stanCertCode: null, stanGrad: null, orgGuid: null, issueTime: null, certExpiTime: null, certStat: null, issueWiunCode: null, stanReviGuid: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
